from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ("documents", "0061_create_new_entitytypes"),
    ]

    operations = [
        migrations.RunSQL(
            """
                INSERT INTO documents_entitytype (id, corpus_id, name, color)
                SELECT uuid_generate_v4(), corpus_id, name,
                CASE WHEN old_type = 'location' THEN '28b62c'
                WHEN old_type = 'date' THEN 'ff4136'
                WHEN old_type = 'person' THEN '3273dc'
                WHEN old_type = 'subject' THEN 'ffdd57'
                WHEN old_type = 'organization' THEN 'ea4aaa'
                WHEN old_type = 'misc' THEN '363636'
                WHEN old_type = 'number' THEN '00d1b2'
                ELSE 'ff0000' END
                FROM (
                    SELECT DISTINCT ON (corpus_id, name) *
                    FROM (
                            SELECT
                                corpus_id,
                                COALESCE(metas->'subtype', old_type) AS name,
                                old_type
                            FROM documents_entity
                        UNION ALL
                            SELECT
                                corpus_id,
                                old_parent_type AS name,
                                old_parent_type AS old_type
                            FROM documents_entityrole
                        UNION ALL
                            SELECT
                                corpus_id,
                                old_child_type AS name,
                                old_child_type AS old_type
                            FROM documents_entityrole
                    ) AS all_old_types
                ) AS old_types
            """,
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
        migrations.RunSQL(
            """
                UPDATE documents_entity e
                SET type_id = t.id
                FROM documents_entitytype t
                WHERE t.corpus_id = e.corpus_id
                AND
                t.name = COALESCE(e.metas->'subtype', e.old_type)
            """,
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
        migrations.RunSQL(
            """
                UPDATE documents_entityrole r
                SET child_type_id = t.id
                FROM documents_entitytype t
                WHERE t.corpus_id = r.corpus_id AND t.name = r.old_child_type
            """,
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
        migrations.RunSQL(
            """
                UPDATE documents_entityrole r
                SET parent_type_id = t.id
                FROM documents_entitytype t
                WHERE t.corpus_id = r.corpus_id AND t.name = r.old_parent_type
            """,
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
    ]
