import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("documents", "0062_migrate_entitytypes"),
    ]

    operations = [
        migrations.RemoveField(
            model_name='entity',
            name='old_type'
        ),
        migrations.RemoveField(
            model_name='entityrole',
            name='old_child_type'
        ),
        migrations.RemoveField(
            model_name='entityrole',
            name='old_parent_type'
        ),
        migrations.RunSQL(
            """
            UPDATE documents_entity SET metas = metas - 'subtype'::text WHERE metas ? 'subtype'
            """,
            reverse_sql=migrations.RunSQL.noop,
            elidable=True,
        ),
        migrations.AlterField(
            model_name='entity',
            name='type',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="entities",
                to="documents.entitytype",
            )
        ),
        migrations.AlterField(
            model_name='entityrole',
            name='child_type',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="child_role",
                to="documents.entitytype",
            )
        ),
        migrations.AlterField(
            model_name='entityrole',
            name='parent_type',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="parent_role",
                to="documents.entitytype",
            )
        )
    ]
