# Generated by Django 2.1.7 on 2019-06-05 08:48

import uuid

import django.core.validators
import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ("ponos", "0003_no_empty_slugs"),
    ]

    operations = [
        migrations.CreateModel(
            name="Agent",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4, primary_key=True, serialize=False
                    ),
                ),
                ("created", models.DateTimeField(auto_now_add=True)),
                ("updated", models.DateTimeField(auto_now=True)),
                (
                    "token",
                    models.CharField(
                        max_length=250,
                        unique=True,
                        validators=[
                            django.core.validators.RegexValidator(r"^[0-9a-f]{64}$")
                        ],
                    ),
                ),
                ("hostname", models.SlugField(db_index=False, max_length=64)),
                (
                    "cpu_cores",
                    models.PositiveSmallIntegerField(
                        validators=[django.core.validators.MinValueValidator(1)],
                    ),
                ),
                (
                    "cpu_frequency",
                    models.BigIntegerField(
                        validators=[django.core.validators.MinValueValidator(1)],
                    ),
                ),
                ("gpu_names", models.TextField()),
                ("gpu_count", models.PositiveSmallIntegerField()),
            ],
        ),
        migrations.AlterModelOptions(
            name="workflow",
            options={"ordering": ("-updated",)},
        ),
        migrations.AddField(
            model_name="task",
            name="agent",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="tasks",
                to="ponos.Agent",
            ),
        ),
        migrations.CreateModel(
            name="AgentUser",
            fields=[],
            options={"proxy": True, "indexes": []},
            bases=("ponos.agent",),
        ),
    ]
