# Generated by Django 3.1 on 2020-10-27 10:44

import django.core.validators
from django.db import migrations, models


def set_default_ping(apps, schema_editor):
    Agent = apps.get_model("ponos", "Agent")
    Agent.objects.all().update(last_ping=models.F("updated"))


class Migration(migrations.Migration):

    dependencies = [
        ("ponos", "0020_fix_admin_blank"),
    ]

    operations = [
        migrations.AddField(
            model_name="agent",
            name="cpu_load",
            field=models.FloatField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name="agent",
            name="ram_load",
            field=models.FloatField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name="agent",
            name="ram_total",
            field=models.BigIntegerField(
                default=1, validators=[django.core.validators.MinValueValidator(1)]
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="agent",
            name="last_ping",
            field=models.DateTimeField(auto_now=True),
            preserve_default=False,
        ),
        migrations.RunPython(
            set_default_ping,
            reverse_code=migrations.RunPython.noop,
            elidable=True,
        ),
        migrations.AlterField(
            model_name="agent",
            name="last_ping",
            field=models.DateTimeField(editable=False),
        ),
    ]
