# Generated by Django 3.2.3 on 2021-07-07 09:09

import django.core.validators
from django.db import migrations, models


def delete_large_artifacts(apps, schema_editor):
    Artifact = apps.get_model("ponos", "Artifact")
    Artifact.objects.filter(
        models.Q(size__lt=1) | models.Q(size__gt=5368709120)
    ).delete()


class Migration(migrations.Migration):

    dependencies = [
        ("ponos", "0025_workflow_farm"),
    ]

    operations = [
        migrations.RunPython(
            delete_large_artifacts, reverse_code=migrations.RunPython.noop
        ),
        migrations.AlterField(
            model_name="artifact",
            name="size",
            field=models.BigIntegerField(
                validators=[
                    django.core.validators.MinValueValidator(1),
                    django.core.validators.MaxValueValidator(5368709120),
                ]
            ),
        ),
    ]
