# Generated by Django 4.1.5 on 2023-02-03 08:39

import django.contrib.postgres.fields.hstore
from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('ponos', '0035_alter_task_tags'),
    ]

    operations = [
        migrations.RenameField(
            model_name="task",
            old_name="env",
            new_name="old_env",
        ),
        migrations.RenameField(
            model_name="task",
            old_name="extra_files",
            new_name="old_extra_files",
        ),
        migrations.AddField(
            model_name='task',
            name='env',
            field=django.contrib.postgres.fields.hstore.HStoreField(default=dict),
        ),
        migrations.AddField(
            model_name='task',
            name='extra_files',
            field=django.contrib.postgres.fields.hstore.HStoreField(default=dict),
        ),
        migrations.RunSQL(
            """
            UPDATE ponos_task SET
                env = (
                    SELECT COALESCE(hstore(array_agg(key), array_agg(value)), hstore(''))
                    FROM jsonb_each_text(old_env)
                ),
                extra_files = (
                    SELECT COALESCE(hstore(array_agg(key), array_agg(value)), hstore(''))
                    FROM jsonb_each_text(old_extra_files)
                )
            ;
            """,
            reverse_sql="""
            UPDATE ponos_task SET
                old_env = env::jsonb,
                old_extra_files = extra_files::jsonb
            ;
            """
        ),
        migrations.RemoveField(
            model_name='task',
            name='old_env',
        ),
        migrations.RemoveField(
            model_name='task',
            name='old_extra_files',
        ),
    ]
