# Generated by Django 3.1 on 2020-09-09 15:26

from django.db import migrations, models

WORKER_REPO_PREFIX = 'https://gitlab.com/teklia/workers/'


def update_repository_types(apps, schema_editor):
    Repository = apps.get_model('process', 'Repository')
    # Defaults the repository to 'worker' type except if defined below
    Repository.objects \
        .filter(url__startswith=WORKER_REPO_PREFIX) \
        .update(type="iiif")


class Migration(migrations.Migration):

    dependencies = [
        ('process', '0018_dataimport_build_entities'),
    ]

    operations = [
        migrations.AddField(
            model_name='repository',
            name='type',
            field=models.CharField(
                default="iiif",
                max_length=10),
            preserve_default=False,
        ),
        migrations.RunPython(
            update_repository_types,
            reverse_code=migrations.RunPython.noop,
            elidable=True
        )
    ]
