SAVEPOINT "{savepoint}";

SELECT "documents_elementpath"."element_id",
       "documents_elementpath"."path"
FROM "documents_elementpath"
WHERE "documents_elementpath"."element_id" IN ('{B}'::uuid,
                                               '{A}'::uuid);

SELECT (MAX("documents_elementpath"."ordering") + 1) AS "max"
FROM "documents_elementpath"
INNER JOIN "documents_element" ON ("documents_elementpath"."element_id" = "documents_element"."id")
WHERE ("documents_element"."type_id" = '{type_id}'::uuid
       AND "documents_elementpath"."path"[array_length("documents_elementpath"."path", 1)] = '{A}'::uuid
       AND "documents_elementpath"."path" && (ARRAY['{A}'::uuid])::uuid[]);

INSERT INTO documents_elementpath (id, element_id, path, ordering)
SELECT uuid_generate_v4(),
       '{B}'::uuid,
       path || '{A}'::uuid,
       1
FROM documents_elementpath
WHERE element_id = '{A}'::uuid ;

INSERT INTO documents_elementpath (id, element_id, path, ordering)
SELECT uuid_generate_v4(),
       child_paths.element_id,
       new_parent_paths.path || '{A}'::uuid || child_paths.path[2:],
       child_paths.ordering
FROM documents_elementpath child_paths,
     documents_elementpath new_parent_paths
WHERE child_paths.path @ > ARRAY['{K}'::uuid,
                                 '{B}'::uuid]
    AND new_parent_paths.element_id = '{A}'::uuid ;

RELEASE SAVEPOINT "{savepoint}"
